#Extend_Trim_structures.　（ExtendStructures(Face)）
# Copyright TAK2
##require 'sketchup.rb'
module TAK2HATA::T2H_BuildingStrcutureTool
module TST1_mod_extend_face_to_plane
	def extend_dc_wall( dcwall , ps1 , cform2 , tf ,tf2)
		tf1 = get_nonscaled_tf(tf)
		clickpt=ps1.transform( tf1.inverse)
		dwbbs = dcwall.definition.bounds
		dctr = dcwall.transformation
		if is_kind(cform2,"Group")
			cf2bbs = cform2.local_bounds
		else
			cf2bbs = cform2.definition.bounds
		end
		#作業はcform1座標空間内で行う(tf1、tf2は各親空間での変位をもっている
		#cform2の壁面(plane1,plane2まで伸縮と仮定しクリック点からの2面までの距離算出、近い方の面にとの交点iptに決定する
		#その後cform1のXの最大lx最小sxと交点ipt1,2のベクトルを比較する
		#両方同方向ならば「伸ばす」。遠い方を基点にして近い側を伸ばす
		#別方向の場合はクリック点からiptまでのベクトルと比較し、同方向側を基点にする
		#変形の*は後ろから掛かっていく
		cf2nvec = vec3d(0,1,0).transform(tf1.inverse*tf2)
		cf2opt1 = pt3d(0,cf2bbs.max.y,0).transform(tf1.inverse*tf2)
		cf2opt2 = pt3d(0,cf2bbs.min.y,0).transform(tf1.inverse*tf2)
		plane1 = [ cf2opt1 , cf2nvec ]
		plane2 = [ cf2opt2 , cf2nvec ]
		line1 = [ pt3d(0,0,0),vec3d(1,0,0)]
		ipt1 =  Geom.intersect_line_plane(line1, plane1)
		ipt2 =  Geom.intersect_line_plane(line1, plane2)
		#交点がない場合は伸縮はキャンセル
		return if not ipt1 or not ipt2
		if (clickpt.x - ipt1.x).abs > ( clickpt.x - ipt2.x).abs
			ipt = ipt2
		else
			ipt = ipt1
		end
		extend_dc_wall_fc2( dcwall , clickpt , ipt ,tf1)
	end

	def extend_dc_wall_fc1( dcwall , ps1 , fc , tf ,tf2)
		tf1 = get_nonscaled_tf(tf)
		fcnvec = fc.normal.transform(tf1.inverse*tf2)
		fcopt1 = fc.vertices[0].position.transform(tf1.inverse*tf2)
		plane1 = [ fcopt1 , fcnvec ]
		line1 = [ pt3d(0,0,0),vec3d(1,0,0)]
		ipt =  Geom.intersect_line_plane(line1, plane1)
		#交点がない場合は伸縮はキャンセル
		return if not ipt
		#get_entities(dcwall).add_cpoint(ipt)
		clickpt=ps1.transform( tf1.inverse)
		extend_dc_wall_fc2( dcwall , clickpt , ipt ,tf1)
	end
	def extend_dc_wall_fc2( dcwall , clickpt , ipt , tf1 )
		
		dwbbs = dcwall.definition.bounds
		dctr = dcwall.transformation
		dist1 = ( dwbbs.max.x - ipt.x )
		dist2 = ( dwbbs.min.x - ipt.x )
		if dist1 * dist2 > 0.0
			#同方向
			if dist1.abs > dist2.abs
				topt = pt3d(dwbbs.max.x,0,0)
				scx = dist1.abs / dwbbs.width
			else
				topt = pt3d(dwbbs.min.x,0,0)
				scx = dist2.abs / dwbbs.width
			end
		elsif dist1 * dist2 < 0.0
			#逆方向
			dist3 = clickpt.x - ipt.x
			if dist3 * dist1
				topt = pt3d(dwbbs.max.x,0,0)
				scx = dist1.abs / dwbbs.width
			else
				topt = pt3d(dwbbs.min.x,0,0)
				scx = dist2.abs / dwbbs.width
			end
		else
		#dist1 dist2が 0.0の場合は変形しない
			return
		end
		if scx > 0.05
			#p scx
			ntr= dctr*Geom::Transformation.scaling(topt,scx,1,1)*dctr.inverse
			dcwall.transform!(ntr)
			if defined?($dc_observers)
				$dc_observers.get_latest_class.redraw_with_undo( dcwall )
			end
			pts = [ pt3d( dwbbs.min.x ,0,0).transform(tf1.inverse), pt3d( dwbbs.max.x ,0,0).transform(tf1.inverse)]
		end
	end
	def extend_do_fcs( ce , fcs , tf1 , plane2 , xvec = vec3d(1,0,0) , modpos = "no" )#####################
	#fc
		vec_arr = []
		vt_arr = []
		fcs.each{|fc|
			fc.edges.each{|ed|
				ed.explode_curve if ed.curve
			}
			fc1ed_IDs = []
			fc.edges.each{|ed|
				fc1ed_IDs.push ed.entityID
			}

			fc.vertices.each{|vt|
				if vt.curve_interior?
				else
					vtp = vt.position.transform( tf1 )

					vline = [ vtp ,  xvec.transform( tf1 ) ]
					ed1 = vt.edges.find_all{|ed| fc1ed_IDs.index( ed.entityID ) == nil }
					
					if ed1 != [] and ed1.size == 1
						ed2 = ed1.find_all{|ed| ed.visible? }
						if ed2.size == 1
							#vline = [ ed1[0].line[0].transform( tf1 ) , ed1[0].line[1].transform( tf1 ) ]
							vpos = ed1[0].start.position
							vec_ed = ed1[0].start.position.vector_to(ed1[0].end.position)
							if vec_ed.length > 0
								vline = [ vpos.transform( tf1 ) , vec_ed.transform( tf1 ) ]
							end
						end
					end
					ipt_v = Geom.intersect_line_plane( vline, plane2 )
					vec_v = vtp.vector_to( ipt_v )
					#if vt.curve_interior?
					#	grp	.add_edges [ vtp ,ipt_v ]
					#end
					if vt_arr.find_all{|vta| vta == vt } == []
					if vec_v.length != 0
						vt_arr.push vt
						vec_arr.push vec_v.transform( tf1.inverse )
					end
					end
				end
			}
		}
		return if vt_arr == nil
		return if vt_arr.size == 0
		get_entities(ce).transform_by_vectors vt_arr , vec_arr
		modify_cline( ce , tf1 , modpos , xvec , plane2 ) if modpos != "no"
		#Sketchup.active_model.commit_operation
	end####################
	def extend_do( ce , fc , tf1 , plane2 , xvec = vec3d(1,0,0) )#####################
		vec_arr = []
		vt_arr = []
			fc.edges.each{|ed|
				ed.explode_curve if ed.curve
			}
			fc1ed_IDs = []
			fc.edges.each{|ed|
				fc1ed_IDs.push ed.entityID
			}

			fc.vertices.each{|vt|
				if vt.curve_interior?
				else
					vtp = vt.position.transform( tf1 )
					vline = [ vtp ,  xvec.transform( tf1 ) ]
					ed1 = vt.edges.find_all{|ed| fc1ed_IDs.index( ed.entityID ) == nil }
					
					if ed1 != [] and ed1.size == 1
						ed2 = ed1.find_all{|ed| ed.visible? }
						if ed2.size == 1
							vline = [ ed1[0].line[0].transform( tf1 ) , ed1[0].line[1].transform( tf1 ) ]
						end
					end
					

					ipt_v = Geom.intersect_line_plane( vline, plane2 )
					vec_v = vtp.vector_to( ipt_v )
					#if vt.curve_interior?
					#	grp	.add_edges [ vtp ,ipt_v ]
					#end
					if vt_arr.find_all{|vta| vta == vt } == []
					if vec_v.length != 0
						vt_arr.push vt
						vec_arr.push vec_v.transform( tf1.inverse )
					end
					end
				end
			}

		return if vt_arr == nil
		return if vt_arr.size == 0
		get_entities(ce).transform_by_vectors vt_arr , vec_arr
		#Sketchup.active_model.commit_operation
	end####################
	def modify_cline( grp , tf1 , modpos , xvec , plane2)
		#構築線も修正する
		pts = []
		pts = path_get_attribute( grp )
		chkcline=false
		get_entities(grp).each{|e|
			if e.typename == "ConstructionLine"
				if e.direction.parallel?( xvec )
					cpt = e.start
					cline = [ cpt.transform(tf1) , xvec.transform(tf1) ]
					ipt_c = Geom.intersect_line_plane( cline, plane2 )
					chkcline = true
					if modpos == "start"
						e.start = ipt_c.transform( tf1.inverse )
						pts[0] = e.start
					else
						e.end = ipt_c.transform( tf1.inverse )
						pts[1] = e.end
					end
				end
			end
		}
		if chkcline == false
			cpt = pts[0]
			cline = [ cpt.transform(tf1) , xvec.transform(tf1) ]
			ipt_c = Geom.intersect_line_plane( cline, plane2 )
			if modpos == "start"
				pts[0] = ipt_c.transform( tf1.inverse )
			else
				pts[1] = ipt_c.transform( tf1.inverse )
			end
		end

		path_set_attribute( grp, pts)
	end
end # of module
end#module
